"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const dynamic_richtext_context_1 = require("../../dynamic-richtext.context");
const react_1 = require("@fluentui/react");
const react_2 = __importStar(require("react"));
const use_debounce_1 = require("use-debounce");
const hoc_1 = require("../../../helpers/hoc");
const content_types_context_1 = require("../../../features/content-types/context/content-types.context");
const dynamic_group_1 = __importDefault(require("../../dynamic-group"));
const loading_bar_1 = __importDefault(require("../../../components/loading-bar"));
const react_hook_form_1 = require("react-hook-form");
const dynamic_form_1 = require("../../dynamic-form");
const useStyles = (0, react_1.makeStyles)((theme) => ({
    form: {
        boxShadow: theme.effects.elevation16,
        padding: 24,
        maxWidth: 960,
        position: 'relative',
        minHeight: 100,
        marginLeft: 'auto',
        marginRight: 'auto',
    },
}));
const DraftComponentBlock = (props) => {
    const ref = (0, react_2.useRef)();
    const classes = useStyles();
    const contentState = props.contentState;
    const contentBlock = props.block;
    const entityKey = contentBlock.getEntityAt(0);
    const { disabled } = (0, dynamic_form_1.useExtendedFormContext)();
    (0, react_2.useEffect)(() => {
        var _a;
        console.log((_a = contentState.getEntity(entityKey).getData()) === null || _a === void 0 ? void 0 : _a.value);
    }, []);
    const { name, value } = contentState.getEntity(entityKey).getData();
    const { setEditorProps, editorProps, forceUpdate } = (0, dynamic_richtext_context_1.useRichtext)();
    const setReadOnly = (readOnly) => {
        setEditorProps(Object.assign(Object.assign({}, editorProps), { readOnly }));
    };
    const { getSingleContentType } = (0, content_types_context_1.useContentTypes)();
    (0, react_2.useEffect)(() => {
        if (name) {
            getSingleContentType.execute({ name });
        }
    }, [name]);
    const methods = (0, react_hook_form_1.useForm)({
        mode: 'all',
        shouldUnregister: true
    });
    const debounced = (0, use_debounce_1.useDebouncedCallback)((value) => {
        contentState.mergeEntityData(entityKey, { value });
        forceUpdate();
    }, 300);
    const handleClickOutside = e => {
        var _a, _b;
        // @ts-ignore
        if (!((_b = (_a = ref === null || ref === void 0 ? void 0 : ref.current) === null || _a === void 0 ? void 0 : _a.contains) === null || _b === void 0 ? void 0 : _b.call(_a, e === null || e === void 0 ? void 0 : e.target))) {
            setReadOnly(false);
        }
    };
    (0, react_2.useEffect)(() => {
        methods.reset(value);
        methods.watch((val) => {
            debounced(val);
        });
        document.addEventListener('mousedown', handleClickOutside);
        return () => document.removeEventListener('mousedown', handleClickOutside);
    }, []);
    return (react_2.default.createElement("div", { ref: ref, className: classes.form, onFocus: () => {
            setReadOnly(true);
        }, onBlur: (e) => {
            var _a;
            const relatedTarget = e === null || e === void 0 ? void 0 : e.relatedTarget;
            if (!((_a = e === null || e === void 0 ? void 0 : e.currentTarget) === null || _a === void 0 ? void 0 : _a.contains(relatedTarget)) && relatedTarget) {
                setReadOnly(false);
            }
        } },
        react_2.default.createElement(react_1.Label, null, name),
        react_2.default.createElement(react_hook_form_1.FormProvider, Object.assign({}, methods),
            react_2.default.createElement(dynamic_form_1.FormHelperContextProvider, { disabled: disabled, narrow: true },
                react_2.default.createElement(loading_bar_1.default, { loading: getSingleContentType === null || getSingleContentType === void 0 ? void 0 : getSingleContentType.loading },
                    react_2.default.createElement(dynamic_group_1.default, { field: getSingleContentType === null || getSingleContentType === void 0 ? void 0 : getSingleContentType.result }))))));
};
exports.default = (0, hoc_1.composeWrappers)({
    contentTypesContext: content_types_context_1.ContentTypesContextProvider,
})(DraftComponentBlock);
